#include "stdafx.h"
#include "ListaAlunos.h"

ListaAlunos::ListaAlunos(int na, char* n)
{
	numero_alunos = na;
	cont_alunos	  = 0;           

	pElAlunoPrim  = NULL;
	pElAlunoAtual = NULL;

	strcpy (nome, n ); 
}

ListaAlunos::~ListaAlunos()
{
   ElAluno *paux1, *paux2;
   
   paux1 = pElAlunoPrim;
   paux2 = paux1;

   while (paux1 != NULL)
   {
	     paux2 = paux1->pProx;
	     delete (paux1);
         paux1 = paux2;		 
   }

   pElAlunoPrim  = NULL;
   pElAlunoAtual = NULL;
}

void ListaAlunos::setAluno ( Aluno* pa )
{
    // Aqui  criado um ponteiro para LAluno
    ElAluno* paux;
    // Aqui  criado um objeto LAluno, sendo seu endereo armazenado em aux
    paux = new ElAluno ( );

    // Aqui recebe uma cpia do objeto interm.
    paux->setAluno ( pa );

    paux->pProx = NULL;
    paux->pAnte = NULL;

    if ( ( cont_alunos < numero_alunos ) && ( pa != NULL) )
    {
    
      if ( pElAlunoPrim == NULL )
      {
         pElAlunoPrim   = paux;
         pElAlunoAtual  = paux;
      }
      else
      {
         pElAlunoAtual->pProx = paux;
         paux->pAnte          = pElAlunoAtual;
         pElAlunoAtual        = paux;
      }
      cont_alunos++;

    }
    else
    {
       //printf ("Aluno no includo. Turma j lotada em %i alunos \n", numero_alunos );
	   cout << "Aluno no includo. Turma j lotada em " << numero_alunos << " alunos." << endl;
    }

}

void ListaAlunos::listeAlunos()
{
    ElAluno* paux;
    paux = pElAlunoPrim;

    while (paux != NULL)
    {
         //printf(" Aluno %s matriculado na Disciplina %s. \n", aux->getNome(), nome);
		 cout << " Aluno " << paux->getNome() << " matriculado na Disciplina " << nome << "." << endl;
         paux = paux->pProx;
    }
}

void ListaAlunos::listeAlunos2()
{
    ElAluno* paux;
    paux = pElAlunoAtual;

    while (paux != NULL)
    {
       //printf(" Aluno %s matriculado na Disciplina %s \n", aux->getNome(), nome);
	   cout << " Aluno " << paux->getNome() << " matriculado na Disciplina " << nome << "." << endl;
       paux = paux->pAnte;
    }

}
